//+--------------------------------------------------------------------+
//|                                      EURUSD / USDCHF Arbitrage.mq4 |
//|                                                                    |
//|                                                                    |
//+--------------------------------------------------------------------+
#property copyright "EURUSD/USDCHF Arbitrage EA"
#property link      "https://www.facebook.com/HonestFreeForexSignals"

extern string Symbol1           = "EURUSD";
extern bool   UseSymbol1        = true;
extern bool   Symbol1IsLong     = true;
extern bool   Symbol1ScaleIn    = true;
extern double Symbol1StartLots  = 0.01;
extern double Symbol1LotStep    = 0.2;
extern double Symbol1TargetLots = 1.0;
extern double S1PipDivergence   = 0.0;
extern int    S1HourToAddNewLots= 23;

extern string Symbol2           = "USDCHF";
extern bool   UseSymbol2        = true;
extern bool   Symbol2IsLong     = true;
extern bool   Symbol2ScaleIn    = true;
extern double Symbol2StartLots  = 0.01;
extern double Symbol2LotStep    = 0.2;
extern double Symbol2TargetLots = 1.0;
extern double S2PipDivergence   = 0.0;
extern int    S2HourToAddNewLots= 23;

extern bool   UseDCA            = true;
extern double LotsToAddDaily    = 0.01;

extern double PercentTakeProfit = 3.0;

extern bool   CloseAllOrdersNow = false;

extern int MagicNumber          = 8675309;

string OrderCommentInitial      = "EURUSD/USDCHF Arbitrage EA";
string OrderCommentMicros       = "EURUSD/USDCHF Arbitrage EA";
double Symbol1TotalLots         = 0.0;
int Symbol1OP                   = OP_BUY;
int Symbol1MODE                 = MODE_ASK;
double Symbol2TotalLots         = 0.0;
int Symbol2OP                   = OP_SELL;
int Symbol2MODE                 = MODE_BID;

bool S1OkToOrder                = false;
bool S2OkToOrder                = false;
bool Ready                      = true;

bool checkIfOkToOrder(int HourToAddNewLots, bool &OkToOrder)
{
  if (Hour() == HourToAddNewLots)
  {
    if (OkToOrder)
    {
      OkToOrder = false;
      return(true);
    }
    else
    {
      return(false);
    }
  }
  else
  {
    OkToOrder = true;
    return(false);
  }
}

bool haveDiverged(string strSymbol, double divergence)
{
  int total = OrdersTotal();
  
  if (divergence == 0.0)
  {
    return(true);
  }
  
  for(int cnt = 0;cnt < total;cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if ((OrderMagicNumber() == MagicNumber) && (OrderSymbol() == strSymbol) && (OrderComment() == OrderCommentInitial))
    {
      if (OrderType() == OP_BUY)
      {
        if ((OrderOpenPrice() - MarketInfo(OrderSymbol(), MODE_BID)) > (divergence * MarketInfo(OrderSymbol(),MODE_POINT)))
        { 
          return(true);
        }
        else
        {
          return(false);
        }
      }
      else
      {
        if ((MarketInfo(OrderSymbol(), MODE_BID) - OrderOpenPrice()) > (divergence * MarketInfo(OrderSymbol(),MODE_POINT)))
        { 
          return(true);
        }
        else
        {
          return(false);
        }
      }
    }
  }  
  return(false);
}

void addToMicroPositions()
{
  if (!UseDCA)
  {
    return;
  }
  
  int resTicket = -1;
  
  if (UseSymbol1)
  {
    if ((haveDiverged(Symbol1,S1PipDivergence)) && (checkIfOkToOrder(S1HourToAddNewLots,S1OkToOrder)))
    {
      resTicket = OrderSend(Symbol1,Symbol1OP,LotsToAddDaily,MarketInfo(Symbol1,Symbol1MODE),13,0,0,OrderCommentMicros,MagicNumber,0,Blue); 
      if (resTicket < 0)
      {
        Alert("OrderSend failed with error #",GetLastError()," For ",Symbol1);
        return(0);
      }
    }
  }
    
  if (UseSymbol2)
  {
    if ((haveDiverged(Symbol2,S2PipDivergence)) && (checkIfOkToOrder(S2HourToAddNewLots,S2OkToOrder)))
    {
      resTicket = OrderSend(Symbol2,Symbol2OP,LotsToAddDaily,MarketInfo(Symbol2,Symbol2MODE),13,0,0,OrderCommentMicros,MagicNumber,0,Blue); 
      if (resTicket < 0)
      {
        Alert("OrderSend failed with error #",GetLastError()," For ",Symbol2);
        return(0);
      }
    }
  }
}

void addToMainPositions()
{
  if ((!Symbol1ScaleIn) && (!Symbol2ScaleIn))
  {
    return;
  }
  
  int resTicket = -1;
  
  if (UseSymbol1)
  {
    if (checkIfOkToOrder(S1HourToAddNewLots,S1OkToOrder))
    {
      resTicket = OrderSend(Symbol1,Symbol1OP,Symbol1LotStep,MarketInfo(Symbol1,Symbol1MODE),13,0,0,OrderCommentInitial,MagicNumber,0,Blue); 
      if (resTicket < 0)
      {
        Alert("OrderSend failed with error #",GetLastError()," For ",Symbol1);
        return(0);
      }
    }
  }
    
  if (UseSymbol2)
  {
    if (checkIfOkToOrder(S2HourToAddNewLots,S2OkToOrder))
    {
      resTicket = OrderSend(Symbol2,Symbol2OP,Symbol2LotStep,MarketInfo(Symbol2,Symbol2MODE),13,0,0,OrderCommentInitial,MagicNumber,0,Blue); 
      if (resTicket < 0)
      {
        Alert("OrderSend failed with error #",GetLastError()," For ",Symbol2);
        return(0);
      }
    }
  }
}

bool lotTargetsReached()
{
  bool retVal = false;
  
  if ((!Symbol1ScaleIn) && (!Symbol2ScaleIn))
  {
    return(true);
  }
  
  bool symbol1TargetReached = false;
  if (Symbol1TotalLots == Symbol1TargetLots)
  {
    symbol1TargetReached = true;
  }
  
  bool symbol2TargetReached = false;
  if (Symbol2TotalLots == Symbol2TargetLots)
  {
    symbol2TargetReached = true;
  }
  
  return((symbol1TargetReached) && (symbol2TargetReached));
}

void closeAllOrders()
{
  int total = OrdersTotal();
  int closeMODE = MODE_ASK;
  bool retVal = false;
  
  for(int cnt = 0;cnt < total;cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if (OrderMagicNumber() == MagicNumber)
    {
      if (OrderType() == OP_BUY)
      {
        closeMODE = MODE_BID;
      }
      else
      {
        closeMODE = MODE_ASK;
      }
      retVal = OrderClose(OrderTicket(),OrderLots(),MarketInfo(OrderSymbol(),closeMODE),5,Red);
      if (!retVal)
      {
        Alert("OrderClose failed with error #",GetLastError()," For ",OrderTicket());
      }
    }
  }
}

double getTotalProfits()
{
  int total = OrdersTotal();
  double profits = 0.0;
  
  for(int cnt = 0;cnt < total;cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if (OrderMagicNumber() == MagicNumber)
    {
      profits += OrderProfit();
    }
  }
  return(profits);
}

bool profitTargetReached()
{
  if (getTotalProfits() >= ((AccountBalance() * (PercentTakeProfit / 100.0))))
  {
    return(true);
  }
  return(false);
}

void openInitialPositions()
{
  int resTicket = -1;
  if (UseSymbol1)
  {
    resTicket = OrderSend(Symbol1,Symbol1OP,Symbol1StartLots,MarketInfo(Symbol1,Symbol1MODE),13,0,0,OrderCommentInitial,MagicNumber,0,Blue); 
    if (resTicket < 0)
    {
      Alert("OrderSend failed with error #",GetLastError()," For ",Symbol1);
      return(0);
    }
    
    resTicket = OrderSend(Symbol2,Symbol2OP,Symbol2StartLots,MarketInfo(Symbol2,Symbol2MODE),13,0,0,OrderCommentInitial,MagicNumber,0,Blue); 
    if (resTicket < 0)
    {
      Alert("OrderSend failed with error #",GetLastError()," For ",Symbol2);
      return(0);
    }
  }
}

bool previousOrdersExist()
{
  Symbol1TotalLots = 0;
  Symbol2TotalLots = 0;

  int total = OrdersTotal();
  for(int cnt = 0;cnt < total;cnt++)
  {
    OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
    if ((OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Symbol1))
    { 
      Symbol1TotalLots += OrderLots();
    }
    
    if ((OrderMagicNumber() == MagicNumber) && (OrderSymbol() == Symbol2))
    {
      Symbol2TotalLots += OrderLots();
    }
    
  }  
    
  if ((Symbol1TotalLots > 0) || (Symbol2TotalLots > 0))
  {
    return(true);
  }
  
  return(false);
}

bool checkMarketWatch()
{
  if (MarketInfo(Symbol1,Symbol1MODE) == 0)
  {
    Alert("Please enable all pairs on Market Watch Window");
    return(false);
  }
  
  if (MarketInfo(Symbol2,Symbol2MODE) == 0)
  {
    Alert("Please enable all pairs on Market Watch Window");
    return(false);
  }
  
  return(true);
}

void initializeLocalVariables()
{
  if (Symbol1IsLong)
  {
    Symbol1OP = OP_BUY;
    Symbol1MODE = MODE_ASK;
  }
  else
  {
    Symbol1OP = OP_SELL;
    Symbol1MODE = MODE_BID;
  }
  
  if (Symbol2IsLong)
  {
    Symbol2OP = OP_BUY;
    Symbol2MODE = MODE_ASK;
  }
  else
  {
    Symbol2OP = OP_SELL;
    Symbol2MODE = MODE_BID;
  }
}

void adjustForIBFXMini()
{
  if (StringLen(Symbol())== 7)
  {
    Symbol1 = Symbol1 + "m";
    Symbol2 = Symbol2 + "m";
  }  
}

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
  // IBFX Append An m To Their Symbols
  adjustForIBFXMini();
  
  initializeLocalVariables();
  
  return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  // All Pairs Must Be On The MarketWatch Window Before We May Trade
  if (!checkMarketWatch())
  {
    return(0);
  }
  
  if (CloseAllOrdersNow)
  {
    closeAllOrders();
    return(0);
  }
  
  if (previousOrdersExist())
  {
    if (profitTargetReached() || (!Ready))
    {
      Ready = false;
      closeAllOrders();
    }
    else
    {
      if (lotTargetsReached())
      {
        addToMicroPositions();
      }
      else
      {
        addToMainPositions();
      }
    }
  }
  else
  {
    Ready = true;
    openInitialPositions();
  }
  
  return(0);
}
//+-----------------------------------------------------------------+